# *** zalozeni tabulky rs_moduly_prava

create table rs_moduly_prava
(
idm tinyint unsigned not null auto_increment,
nazev_modulu varchar(60),
ident_modulu varchar(20),
fks_prava_users text,
all_prava_users tinyint unsigned default 0,
nazev_menu varchar(40),
liclakce_menu varchar(60),
link_menu varchar(60),
poradi_menu smallint unsigned default 0,
zakladni_modul tinyint unsigned default 0,
jen_admin_modul tinyint unsigned default 0,
blokovat_modul tinyint unsigned default 0,
barva_txt varchar(10),
barva_bg varchar(10),
plugin tinyint unsigned default 0,
fk_id_plugin smallint unsigned default 0,
primary key(idm)
);

# *** Vlozeni default dat do tabulky rs_moduly_prava

insert into rs_moduly_prava values (1, 'Systémový modul', 'sys1', '', 1, 'Logout', 'admin/asystem.php', 'akce=Logout', 60, 1, 0, 0, '', '', 0, 0);
insert into rs_moduly_prava values (2, 'Modul users', 'users', '1', 0, 'Editace autorů', 'admin/auser.php', 'akce=ShowUser', 1, 1, 1, 0, '', '', 0, 0);
insert into rs_moduly_prava values (3, 'Modul redaktor', 'redaktor', '1', 0, 'Redaktor', 'admin/aredaktor.php', 'akce=PubClanku', 14, 0, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (4, 'Modul správa bloků', 'bloky', '1', 0, 'Úprava bloků', 'admin/aengine.php', 'akce=Columns', 4, 1, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (5, 'Modul rubriky', 'topic', '1', 0, 'Úprava rubrik', 'admin/atopic.php', 'akce=ShowTopic', 5, 1, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (6, 'Modul správa článků', 'clanky', '1', 0, 'Editace článků', 'admin/aarticles.php', 'akce=Articles', 2, 0, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (7, 'Modul Novinky', 'news', '1', 0, 'Editace novinek', 'admin/anews.php', 'akce=ShowNews', 3, 0, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (8, 'Modul komentáře', 'comment', '1', 0, 'Komentáře', 'admin/acomment.php', 'akce=ShowComment', 13, 0, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (9, 'Modul download souborů', 'files', '1', 0, 'Download souborů', 'admin/adownload.php', 'akce=ShowFile', 7, 0, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (10, 'Modul weblinks', 'links', '1', 0, 'Úprava weblinků', 'admin/aweblinks.php', 'akce=ShowLink', 8, 0, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (11, 'Modul ankety', 'ankety', '1', 0, 'Editace anket', 'admin/aankety.php', 'akce=ShowInquiry', 9, 0, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (12, 'Modul stránkový alias', 'alias', '1', 0, 'Stránkové aliasy', 'admin/aalias.php', 'akce=ShowAlias', 10, 0, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (13, 'Modul statistika', 'stat', '1', 0, 'Statistika', 'admin/astat.php', 'akce=ShowStatistic', 16, 0, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (14, 'Modul záloha DB', 'dump', '1', 0, 'Záloha DB', 'admin/adump.php', 'akce=ShowDump', 17, 1, 1, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (15, 'Modul čtenáři', 'ctenari', '1', 0, 'Čtenáři', 'admin/areaders.php', 'akce=ShowReaders', 15, 0, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (16, 'Modul konfigurace', 'config', '1', 0, 'Konfigurace', 'admin/aconfig.php', 'akce=ShowConfig', 6, 1, 1, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (17, 'Modul reklama', 'reklama', '1', 0, 'Reklamní systém', 'admin/aadvert.php', 'akce=ShowAdvert', 12, 0, 0, 0, NULL, NULL, 0, 0);
insert into rs_moduly_prava values (18, 'Modul interní galerie', 'intergal', '1', 0, 'Galerie obrázků', 'admin/aimggal.php', 'akce=ImgGal', 11, 0, 0, 0, NULL, NULL, 0, 0);

# *** zalozeni tabulky rs_vazby_prava

create table rs_vazby_prava
(
idv int unsigned not null auto_increment,
fk_id_nadrizeny int unsigned not null,
fk_id_podrizeny int unsigned not null,
primary key(idv)
);

# *** pridani sloupce im_ident do tabulky rs_user

alter table rs_user add im_ident varchar(40) default '' after url;

# *** pridani sloupce pravo_vydavat do tabulky rs_user

alter table rs_user add pravo_vydavat tinyint unsigned not null after admin;

# *** pridani sloupce blokovat do tabulky rs_user

alter table rs_user add blokovat tinyint unsigned default '0' not null;

# *** pridani sloupce pocet_chyb do tabulky rs_user

alter table rs_user add pocet_chyb smallint unsigned default '0' not null;

# *** pridani sloupce pom_str do tabulky rs_user

alter table rs_user add pom_str varchar(50) default '';

# *** pridani sloupce uzavrena do tabulky rs_ankety

alter table rs_ankety add uzavrena tinyint unsigned not null default 0 after zobrazit;

# *** zalozeni tabulky rs_kontrola_ip

create table rs_kontrola_ip
(
idk int unsigned not null auto_increment,
ip_adresa varchar(20),
cas datetime,
pocet smallint default 0,
typ varchar(30),
primary key(idk)
);

# *** vymazani tabulky rs_user_prava

drop table if exists `rs_user_prava`;

# *** pridani sloupce posledni_login do tabulky rs_ctenari

alter table rs_ctenari add posledni_login datetime not null;

# *** pridani sloupce registrovany do tabulky rs_komentare

alter table rs_komentare add registrovany tinyint unsigned not null;

# *** pridani sloupce reg_prezdivka do tabulky rs_komentare

alter table rs_komentare add reg_prezdivka varchar(20) not null;

# *** pridani sloupce reg_id do tabulky rs_komentare

alter table rs_komentare add reg_id int unsigned not null;

# *** pridani sloupce jazyk_prostredi do tabulky rs_user

alter table rs_user add jazyk_prostredi varchar(10) after pocet_chyb;

# *** obnoveni univerzalniho uzivatele

delete from rs_user where idu=1;
insert into rs_user values (1, 'admin', '955db0b81ef1989b4a4dfeae8061a9a6', 'administrator', 'admin@server.cz', 'http://www.server.cz', '', 2, 1, 0, 0, 'cz', '');